<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

    use Doctrine\ORM\EntityManager;
    use Teknisa\PED\Modules\Pedidos\Factories\Ped05900ComposicaoPrecoProdutoFactory ;
    use Teknisa\Libs\Util\DateUtil;
    use Zeedhi\Framework\DTO\Response\Error;
    use Teknisa\Libs\Util\Environment;
    
    class Ped05900ComposicaoPrecoProdutoService {
        
        protected $entityManager;
    	protected $environment;
    	protected $ComposicaoPrecoProdutoFactory;
    
    	public function __construct(EntityManager $entityManager, Environment $environment, Ped05900ComposicaoPrecoProdutoFactory $ComposicaoPrecoProdutoFactory){
    		$this->entityManager  = $entityManager;
    		$this->environment	= $environment;
    		$this->ComposicaoPrecoProdutoFactory = $ComposicaoPrecoProdutoFactory;
    	}
    	
    	public function getPrecobase($row){
    	    return $this->ComposicaoPrecoProdutoFactory->getPrecobase($row);
    	}
    	
    	public function updateForm($row){
    	     return $this->ComposicaoPrecoProdutoFactory->updateForm($row);
    	}
    	
    	public function openGridCalc($row){
    	    $dados = array();
    	    $produtos = $this->ComposicaoPrecoProdutoFactory->openGridCalc($row);
    	    
    	    foreach($produtos as $produto){

    	       $result = $this->CalculaPrecoProd($produto); 
    	       $produto['VRITEPREBASE'] = $result;

    	       array_push($dados, $produto);
    	    }
            return $dados;
    	}
    	
    	public function CalculaPrecoProd($produto){
            try{ 
                $PC = $produto['VRCUSTOATUAL'];
                $formula = $produto['DSFORMCALCPRECO'];
                
                $arrayID = [];
                $arrayValue = [];
        	    $composicao = array(array("id" => "PC", "valor" => $produto['VRCUSTOATUAL']));
        	    
    	        $dadosPreco = $this->ComposicaoPrecoProdutoFactory->getComposicao($produto);
    	        
    	        foreach($dadosPreco as $dado){
                    
                    if($dado['VRPEFORMPREC'] != 0){
                        $itens = array( "id" => $dado['SGITFORPRECO'], "valorPerc" => $dado['VRPEFORMPREC']);
                    }else if($dado['VRFATFORMPREC'] != 0){
                        $itens = array( "id" => $dado['SGITFORPRECO'], "valorLiq" => $dado['VRFATFORMPREC']);
                    }
    	            array_push($composicao, $itens);
    	        }
    
    	        foreach($composicao as $comp){
    	            
    	            if($comp['id'] != 'PC'){
                        
                        if(array_key_exists("valorPerc", $comp)){
                            $value = $comp['valorPerc'] * $PC / 100;
                        }else if(array_key_exists("valorLiq", $comp)){
                            $value = $comp['valorLiq'];
                        }
                        
                        array_push($arrayID, $comp['id']);
                        array_push($arrayValue, $value);
                    }else{
                        array_push($arrayID, $comp['id']);
                        array_push($arrayValue, $PC);
                    }
    
    	            $strCalc = str_replace($arrayID, $arrayValue, $formula);
    	        }
	        
	           eval("\$strCalc = $strCalc;"); 
	        }catch (\Exception $e) {
	            $strCalc = null;
	        }
            
            return $strCalc;
        }
        
        public function precoOpcio($prod){
            
            return $this->ComposicaoPrecoProdutoFactory->precoOpcio($prod);
        }
        
        public function updatePrecoOpcio($prod, $cdoperador, $valIni, $dtinivalid){
            return $this->ComposicaoPrecoProdutoFactory->updatePrecoOpcio($prod, $cdoperador, $valIni, $dtinivalid);
        }
        
        public function precoProd($prod){
            
            return $this->ComposicaoPrecoProdutoFactory->precoProd($prod);
        }
        
    	public function insertPrecoProd($prod,$cdoperador, $valIni, $data){

            return $this->ComposicaoPrecoProdutoFactory->insertPrecoProd($prod,$cdoperador, $valIni, $data);
        }
        
        public function updatePrecoProd($prod,$valIni){
            
            return $this->ComposicaoPrecoProdutoFactory->updatePrecoProd($prod, $valIni);
        }
        
        public function histCustProd($prod){
            
            return $this->ComposicaoPrecoProdutoFactory->histCustProd($prod);
        }
        
        public function insereHistCustProd($prod){
            
            return $this->ComposicaoPrecoProdutoFactory->insereHistCustProd($prod);
        }
        
        public function updataHistCustProd($prod){
            
            return $this->ComposicaoPrecoProdutoFactory->updataHistCustProd($prod);
        }
    }
?>