<?php
namespace Teknisa\Model\Geral\Repositories;

use \Doctrine\DBAL\Connection;

class ZhuAccessControlElement extends \Doctrine\ORM\EntityRepository {
    
    public function getRulesByGroupId($groupId,$projectId){
        $query = <<<SQL
                  SELECT ACR.ID
                  FROM ZHU_ACCESS_CONTROL_RULE ACR
                    JOIN ZHU_ACCESS_CONTROL_ELEMENT ACE ON (ACE.ID = ACR.ACCESS_CONTROL_ELEMENT_ID)
                   WHERE ACE.PROJECT_ID = :PROJECT_ID
                     AND ACR.GROUP_ID IN (:GROUP_ID)
SQL;

        $params = array(
              "GROUP_ID" => $groupId,
            "PROJECT_ID" => $projectId,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getElements($organizationId,$cdCliente,$projectId,$groupId,$isteknisa){
        $query = <<<SQL
               SELECT RULE.*,
                  ELEMENT.UNIQUE_ID AS ELEMENT_UNIQUE_ID,
                  ELEMENT.PROJECT_ID
                FROM ZHU_ACCESS_CONTROL_RULE RULE
                JOIN ZHU_ACCESS_CONTROL_ELEMENT ELEMENT ON RULE.ACCESS_CONTROL_ELEMENT_ID = ELEMENT.ID
                WHERE ELEMENT.PROJECT_ID          = :PROJECT_ID
                AND RULE.GROUP_ID                 = :GROUP_ID
                AND RULE.ORGANIZATION_ID          = :ORGANIZATION_ID
SQL;
    if(!$isteknisa){
        $query = <<<SQL
              SELECT RULE.*,
                  ELEMENT.UNIQUE_ID AS ELEMENT_UNIQUE_ID,
                  ELEMENT.PROJECT_ID
                FROM ZHU_ACCESS_CONTROL_RULE RULE
                JOIN ZHU_ACCESS_CONTROL_ELEMENT ELEMENT ON RULE.ACCESS_CONTROL_ELEMENT_ID = ELEMENT.ID
                JOIN CP_PERFILACESSO CPP ON (CPP.NRPERFILACESSO = RULE.GROUP_ID)
                WHERE ELEMENT.PROJECT_ID          = :PROJECT_ID
                AND RULE.GROUP_ID                 = :GROUP_ID
                AND RULE.ORGANIZATION_ID          = :ORGANIZATION_ID
                AND CPP.CDCLIENTE                 = :CD_CLIENTE
SQL;
    }

        $params = array(
              "GROUP_ID" => $groupId,
            "PROJECT_ID" => $projectId,
            "CD_CLIENTE" => $cdCliente,
       "ORGANIZATION_ID" => $organizationId,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getRules($cdCliente,$projectId,$groupId){
        $query = <<<SQL
                SELECT    ACL.UNIQUE_ID,
                          ACL.NAME,
                          CASE
                            WHEN RULE.RULE IS NULL
                            THEN 'A'
                            ELSE RULE.RULE
                          END AS RULE
                 FROM
                          (SELECT ZE.ELEMENT_ID,
                                  ZE.UNIQUE_ID,
                                  ZE.TYPE,
                                  ZE.PROJECT_ID,
                                  ZE.NAME,
                                  ZE.LABEL,
                                  ZE.PARENT_ID,
                                  ZE.IS_ACTIVE,
                                  P.ID AS PROFILE_ID
                             FROM
                                    (SELECT ID AS ELEMENT_ID,
                                            UNIQUE_ID,
                                            TYPE,
                                            PROJECT_ID,
                                            NAME,
                                            LABEL,
                                            PARENT_ID,
                                            IS_ACTIVE
                                       FROM ZHU_ACCESS_CONTROL_ELEMENT
                                      WHERE PROJECT_ID = :PROJECT_ID
                                    ) ZE,
                                     (SELECT ID FROM
                                      (SELECT DISTINCT GROUP_ID AS ID FROM ZHU_ACCESS_CONTROL_RULE WHERE IS_ACTIVE = 'Y'
                                        AND GROUP_ID IN(:GROUP_ID)
                                      )
                                    ) P
                                  WHERE P.ID IN(:GROUP_ID)
                          ) ACL
                        LEFT JOIN
                          (SELECT * FROM ZHU_ACCESS_CONTROL_RULE WHERE IS_ACTIVE = 'Y'
                          ) RULE
                        ON ACL.ELEMENT_ID  = RULE.ACCESS_CONTROL_ELEMENT_ID
                        AND ACL.PROFILE_ID = RULE.GROUP_ID
                        WHERE EXISTS
                          (SELECT ID
                          FROM ZHU_ACCESS_CONTROL_RULE
                          WHERE RULE                   <> 'A'
                          AND GROUP_ID                 IN(:GROUP_ID)
                          AND ACCESS_CONTROL_ELEMENT_ID = ACL.ELEMENT_ID
                          )
SQL;

        $params = array(
              "GROUP_ID" => $groupId,
            "PROJECT_ID" => $projectId,
        );

        $paramTypes = array(
            'GROUP_ID' => Connection::PARAM_STR_ARRAY,
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params, $paramTypes);
    }

    
}