var Exp01800_cancelamento_Controller = function(General, templateManager, ScreenService, ZHPromise, ZhFilterPreferences) {
    
    this.openFilter = function(widget) {
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        });
    };
	
	this.getFilialLogada = function() {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return General.callRestEngine('ped#/crud/filial', 'FilterData', filter);
    };

    this.recarregaWidget = function(){
        var widget = templateManager.container.getWidget('widgetCancelamento');
        widget.reload();
    };

    this.habilitaCancelarExped = function(){
        var widget = templateManager.container.getActiveWidget();
        if( widget.getAction('cancelarExpedicao')){
            if(widget.getCheckedRows().length) {
                widget.getAction('cancelarExpedicao').isVisible = true;
            } else {
                widget.getAction('cancelarExpedicao').isVisible = false;
            }
        }
    };

    this.cancelarExpedicao = function() {

        var rows = templateManager.container.getWidget('widgetCancelamento').getCheckedRows();
        var widget = templateManager.container.getActiveWidget();

        General.callRestEngine('ped_expedicao#/cancelarExpedicao','DataSet', rows).then(function(callback){
            
            callback.dataset.data.forEach(function(item){
                item.IDERRO = ScreenService.i18n(item.IDERRO);  
            });

            widget.unSelectAll();
            widget.reload();
            var widgetRetornoCancelamento = templateManager.container.getWidget('popUpRetornoCancelamento');
            
            setTimeout(function(){
                ZHPromise.all(ScreenService.openPopup(widgetRetornoCancelamento)).then(function(){
                    widgetRetornoCancelamento.dataSource.data = callback.dataset.data;
                });
            }, 1000);
        }.bind(this)).catch(function(callback){
            ScreenService.showMessage(callback.data.error);
            ScreenService.closePopup(widget).then(function(){
                ScreenService.closePopup();
            });
        }.bind(this));
    };
};


Configuration(function(ContextRegister){
    ContextRegister.register('Exp01800_cancelamento_Controller', Exp01800_cancelamento_Controller);
});