var Ped05700_importacao_Solicitacao_Compras_Controller = function (ScreenService, General, templateManager, restEngine, localStorageEngine, Ped05700_importacao_Solicitacao_Compras_Service, Endereco, ZhFilterPreferences, ZHPromise, Ger01100_Transportadora_Service) {
    
    this.checkedRows   = [];
    
    this.openFilter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
           this.setFilter();
        }.bind(this)); 
    };
    
    this.controlaVisibilidadeImportar = function (widget){
    	var checkedRows = widget.getCheckedRows();
        
    	if(checkedRows.length > 0){
    		widget.getAction('importarSolicitacoes').isVisible = true;
    	}else{
    		widget.getAction('importarSolicitacoes').isVisible = false;
    	}
    };
    
    this.controlaImportacaoSelectAll = function (widget){
        widget.getCheckedRows().forEach(function(row){
            if(row.IDMARCADO == 'S'){
                widget.unSelectAll();
                ScreenService.showMessage('Existem solicitações já importadas dentre as selecionadas!');
                widget.getAction('importarSolicitacoes').isVisible = false;
            }
        }.bind(this));
    };
    
    this.controlaImportacao = function (widget){
        var row = widget.selectedRow;
        if(row.IDMARCADO == 'S'){
            ScreenService.showMessage('Solicitação já importada!');
            row.__isSelected = false;
            widget.getAction('importarSolicitacoes').isVisible = false;
        }
    };
    
    this.setDataSourceFilterSolic = function(){
        var widget = templateManager.container.getActiveWidget();
        var rows = widget.currentRow;
        var filtro = [];
        
        if(rows.CDFILSOLI && rows.CDFILSOLI != []){
            if(rows.CDFILSOLI.length > 1){
                var filiaisSolic ="";
                rows.CDFILSOLI.forEach(function(filiSoli){
                    filiaisSolic += "_" +filiSoli;
                });
                filiaisSolic = filiaisSolic+ "_";
                filtro.push(
                    {
        				"name": "P_CDFILIAL",
        				"operator": "IN",
        				"value":filiaisSolic
                    },
                    {
                        "name": "P_TCDFILIAL",
        				"operator": "=",
        				"value":null
                    }
                );
            }else if(rows.CDFILSOLI.length == 1 ){
               filtro.push(
                    {
        				"name": "P_CDFILIAL",
        				"operator": "=",
        				"value":rows.CDFILSOLI
                    },
                    {
                        "name": "P_TCDFILIAL",
        				"operator": "=",
        				"value":null
                    }
                ); 
            }
            
        }else{
            filtro.push(
                {
    				"name": "P_CDFILIAL",
    				"operator": "=",
    				"value":null
                },
                {
                    "name": "P_TCDFILIAL",
    				"operator": "=",
    				"value":"T"
                }
            );
        }
        filtro.push(
                {
    				"name": "P_DTSOLCMPFIN",
    				"operator": "=",
    				"value":widget.currentRow.DTSOLCMP.end
                },
                {
                    "name": "P_DTSOLCMPINI",
    				"operator": "=",
    				"value":widget.currentRow.DTSOLCMP.start
                }
        );
        widget.getField('NRSOLICMP').dataSourceFilter = [];
        widget.getField('NRSOLICMP').dataSourceFilter = filtro;
        widget.getField('NRSOLICMP').reload();

    };

    
    this.controlaDataSource = function (widget){
        var filtro = templateManager.container.getActiveWidget();
        
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": 'FILIAL_LOGADA'
                }
            ];
            
        General.callRestEngine('ped#/crud/paramimppedido', 'FilterData', filter).then(function(callback){
            var row = callback.dataset.paramimppedido[0];
            if(row){
                if(row.IDIMPSCDTENTR == 'S'){
                    if(filtro.currentRow.SUBGRUPSN == 'N'){
                        widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos_data";
                        widget.reload();
                    }else if(filtro.currentRow.SUBGRUPSN == 'S'){
                       widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos_data_grupo";
                       widget.reload();
                    }
                }else{
                    if(filtro.currentRow.SUBGRUPSN == 'N'){
                        widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos";
                        widget.reload();
                    }else if(filtro.currentRow.SUBGRUPSN == 'S'){
                        widget.dataSource.name = "ped_pedidos#/crud/filial_solicita_pedidos_grupo";
                        widget.reload();
                    }
                }
            }
            
        });
        
    };
 
    this.setFilter = function(){
        var widget = templateManager.container.getActiveWidget();
    	var NDate = new Date();
        var today = NDate.getDate() + "/" + parseInt(NDate.getMonth()+1)+ "/" + NDate.getFullYear();
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : today
        };
        widget.getField('SUBGRUPSN').value('N');
        widget.currentRow.SUBGRUPSN = "N";
        widget.getField('DTSOLCMP').setValue(interval);
        
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": 'FILIAL_LOGADA'
                }
            ];
            
        General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback){
            var tipoPrec = callback.dataset.parampedido[0].IDTABPRECO;
            if(tipoPrec == 1){
                widget.getField('NMFATORPRECO').isVisible = false;
            }else{
                widget.getField('NMFATORPRECO').isVisible = true;
            }
            General.callRestEngine('ped#/crud/paramimppedido', 'FilterData', filter).then(function(callback){
                var row = callback.dataset.paramimppedido[0];
                if(row){
                    if(row.IDIMPSCDTENTR == 'S'){
                        widget.getField('DTPROGENTR').validations = {requiredInterval:true};
                    }else{
                        widget.getField('DTPROGENTR').validations = {};
                    }
                }
            });
            
        });
         var filterProdutos = [
            {
                "name": 'IDPRODATIVPR',
                "operator": '=', 
                "value": 'S'
                
            }
        ];
        /*General.callRestEngine('ped#/crud/produto_arvore', 'FilterData', filterProdutos).then(function(callback){
            widget.getField('NMPRODUTOINI').dataSource.data = callback.dataset.produto_arvore;
            widget.getField('NMPRODUTOFIN').dataSource.data = callback.dataset.produto_arvore;
            widget.redraw();
        });*/
        widget.reload();
    };

    this.importaSolicitacao = function (widget){
    	var checkedRows = widget.getCheckedRows();
        var TCDSUBGRPROD;
        var CDFATORPRECO;
        var CDSUBGRPROD;
        var CDGRUPO;
        
         
        if(widget.appliedFilter.FILTER_ROW.SUBGRUPSN == 'S'){
            CDGRUPO = widget.appliedFilter.FILTER_ROW.CDGRUPPROD[0];
            if(widget.appliedFilter.FILTER_ROW.TCDSUBGRPROD == 'T'){
                CDSUBGRPROD = null;
                TCDSUBGRPROD = widget.appliedFilter.FILTER_ROW.TCDSUBGRPROD;
            }else{
                CDSUBGRPROD = widget.appliedFilter.FILTER_ROW.CDSUBGRPROD[0];
                TCDSUBGRPROD = null;
            }
        }else{
            CDGRUPO = null; 
            CDSUBGRPROD = null;
            TCDSUBGRPROD = 'T';
        }
        
        if(widget.appliedFilter.FILTER_ROW.NMFATORPRECO != ''){
            CDFATORPRECO = widget.appliedFilter.FILTER_ROW.CDFATORPRECO;
        }else{
            CDFATORPRECO = null;
        }

        function setValue(row){
            row.TCDSUBGRPROD = TCDSUBGRPROD;
            row.CDFATORPRECO = CDFATORPRECO;
            row.CDSUBGRPROD = CDSUBGRPROD;
            row.CDGRUPO = CDGRUPO;
        }

        checkedRows.forEach(setValue);
        
        Ped05700_importacao_Solicitacao_Compras_Service.importarSolicitacoes(checkedRows).then(function(callback){
            var widgetRetornoImportacao = templateManager.container.getWidget('popUpRetornoImportacaoSolicitacoes');
            var widget = templateManager.container.getWidget('gridSolicitaCompra');
            if(callback.dataset.retorno[0].NMPRODUTO){
                widgetRetornoImportacao.getField('NMPRODUTO').isVisible = true;
                widgetRetornoImportacao.reload();
            }else{
                widgetRetornoImportacao.getField('NMPRODUTO').isVisible = false;
                widgetRetornoImportacao.reload();
            }
            if(callback.dataset.retorno){

                ScreenService.openPopup(widgetRetornoImportacao).then(function(){
                    widgetRetornoImportacao.dataSource.data = callback.dataset.retorno;
                    widget.getAction('importarSolicitacoes').isVisible = false;
                    widgetRetornoImportacao.reload();
                });
                
            }
            widget.unSelectAll();
            widget.getAction('importarSolicitacoes').isVisible = false;
            widget.reload();
            
        });
    };
   
    this.newImportacao = function(widget){
		General.newRow(widget);
	};
    
    
    this.filtroProdutoInicial = function() {
        var widget = templateManager.container.getActiveWidget();
        var row = widget.currentRow;
        var produtoInicial = row.CDPRODUTOINI;
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');
        
        if(widget.currentRow.SUBGRUPSN == 'S' && !widget.currentRow.CDSUBGRPROD){
            if(widget.currentRow.TCDSUBGRPROD == 'L'){
                ScreenService.showMessage('Sub Grupo deve ser informado.');
                widget.getField('NMPRODUTOINI').setValue("");
            }else{
                if(produtoInicial == undefined || produtoInicial == ''){
                    NMPRODUTOFIN.readOnly = true;
                    widget.currentRow.NMPRODUTOFIN = "";
                    NMPRODUTOFIN.value('');
                    
                    widget.reload();
                }else{
                    NMPRODUTOFIN.readOnly = false;
                    this.setDataSourceFilterSubGrup();
                }
                
            }
        }else if(widget.currentRow.SUBGRUPSN == 'N'){
        
            if(produtoInicial == undefined || produtoInicial == ''){
                NMPRODUTOFIN.readOnly = true;
                widget.currentRow.NMPRODUTOFIN = "";
                NMPRODUTOFIN.value('');
                widget.reload();
            }else{
                NMPRODUTOFIN.readOnly = false;
                this.setDataSourceFilterSubGrup();
            }
        }else if(produtoInicial && produtoInicial != ''){
            NMPRODUTOFIN.readOnly = false;
            this.setDataSourceFilterSubGrup();
        }else{
            widget.currentRow.NMPRODUTOFIN = "";
            NMPRODUTOFIN.value('');
            NMPRODUTOFIN.readOnly = true;
            widget.reload();
        }
        
    };
    
    this.filtroProdutoFinal = function() {
        var widget = templateManager.container.getActiveWidget();
        var NMPRODUTOFIN = widget.getField('NMPRODUTOFIN');
        var produtoInicial = widget.currentRow.CDPRODUTOINI;
        var produtoFinal = widget.currentRow.CDPRODUTOFIN;

        if(produtoInicial > produtoFinal){
            if(produtoFinal){
                ScreenService.showMessage('Produto Final deve ser maior que o produto inicial!');
                NMPRODUTOFIN.setValue('');
            }
        }

    };
    
    this.setDataSourceFilterSubGrup = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.getField('NMPRODUTOINI').dataSourceFilter = [];
    	widget.getField('NMPRODUTOFIN').dataSourceFilter = [];
        var filterProdutos = [];
        if(widget.currentRow.SUBGRUPSN =="S"){
            General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
                var filter = [
                    {
                        "name": 'P_CDFILIAL',
                        "operator": '=', 
                        "value": response.dataset.filial[0].CDFILIAL
                        
                    },
                    {
                        "name": 'P_CDFILIALPROC',
                        "operator": '=', 
                        "value": response.dataset.filial[0].CDFILIAL
                        
                    }
                ];
                General.callRestEngine('ped_pedidos#/crud/grupo_prod', 'FilterData', filter).then(function(subGrupo) {
                   widget.currentRow.CDGRUPPROD = subGrupo.dataset.grupo_prod[0].CDGRUPPROD;
                    widget.getField('CDSUBGRPROD').dataSourceFilter =[
                        {
                            "name": 'P_CDGRUPO',
                            "operator": '=', 
                            "value": widget.currentRow.CDGRUPPROD
                            
                        }
                    ];
                    
                    filterProdutos.push(
                        {
                            "name": 'P_CDGRUPO',
                            "operator": '=', 
                            "value": widget.currentRow.CDGRUPPROD
                            
                        }
                    );
                    if(widget.currentRow.CDSUBGRPROD){
                        var grupos = "";
                        if(widget.currentRow.CDSUBGRPROD.length > 1){
                            widget.currentRow.CDSUBGRPRO.forEach(function(grupo){
                                grupos += "_" +grupo;
                            });
                            grupos = grupos+ "_";
                            filterProdutos.push(
                                {
                                    "name": 'P_CDSUBGRPROD',
                                    "operator": '=', 
                                    "value": grupos
                                    
                                },
                                {
                                    "name": 'P_TCDSUBGRPROD',
                                    "operator": '=', 
                                    "value": null
                                    
                                }
                            );
                        }else if(widget.currentRow.CDSUBGRPROD.length == 1){
                            filterProdutos.push(
                                {
                                    "name": 'P_CDSUBGRPROD',
                                    "operator": '=', 
                                    "value": widget.currentRow.CDSUBGRPROD
                                    
                                },
                                {
                                    "name": 'P_TCDSUBGRPROD',
                                    "operator": '=', 
                                    "value": null
                                    
                                }
                            );
                        }
                    }else{
                        filterProdutos.push(
                                {
                                    "name": 'P_CDSUBGRPROD',
                                    "operator": '=', 
                                    "value": null
                                    
                                },
                                {
                                    "name": 'P_TCDSUBGRPROD',
                                    "operator": '=', 
                                    "value": "T"
                                    
                                }
                            );
                    }
                    widget.getField('NMPRODUTOINI').dataSource.name ='ped_pedidos#/crud/prodsubgrupo';
    				widget.getField('NMPRODUTOFIN').dataSource.name ='ped_pedidos#/crud/prodsubgrupo';
    				widget.getField('NMPRODUTOINI').dataSourceFilter = filterProdutos;
    				widget.getField('NMPRODUTOFIN').dataSourceFilter = filterProdutos;
    				widget.redraw();
                });
            });
        } else{
            widget.getField('NMPRODUTOFIN').dataSource.name ='ped#/crud/produto_arvore';
    		widget.getField('NMPRODUTOFIN').dataSourceFilter = filterProdutos;
    		widget.getField('NMPRODUTOINI').dataSource.name ='ped#/crud/produto_arvore';
    		widget.getField('NMPRODUTOINI').dataSourceFilter = filterProdutos;
    		widget.redraw();
        }
    };
    
    this.validaFiltroSubgrupo = function(){
        var widget = templateManager.container.getActiveWidget();
        widget.getField('NMPRODUTOINI').setValue("");
        widget.getField('NMPRODUTOFIN').setValue("");
        if(widget.currentRow.SUBGRUPSN == "S"){
            widget.getField('TCDSUBGRPROD').readOnly = false;
            widget.getField('TCDSUBGRPROD').validations = {required:true};
            widget.getField('TCDSUBGRPROD').reload();
            if(widget.currentRow.TCDSUBGRPROD == "L"){
                this.setDataSourceFilterSubGrup();
                widget.getField('CDSUBGRPROD').readOnly = false;
                widget.getField('CDSUBGRPROD').validations = {required:true};
                widget.getField('NMPRODUTOINI').readOnly = false;
   
            }else if(widget.currentRow.TCDSUBGRPROD == "T"){
                this.setDataSourceFilterSubGrup();
                widget.getField('CDSUBGRPROD').setValue('');
                widget.getField('CDSUBGRPROD').readOnly = true;
                widget.getField('CDSUBGRPROD').validations = {};
                widget.getField('NMPRODUTOINI').readOnly = false;
            }
        }else{
           this.setDataSourceFilterSubGrup();
           widget.getField('NMPRODUTOINI').readOnly = false;
           widget.getField('TCDSUBGRPROD').readOnly = true;
           widget.getField('TCDSUBGRPROD').validations = {};
           widget.getField('TCDSUBGRPROD').setValue("");
           widget.getField('CDSUBGRPROD').validations = {};
           widget.getField('CDSUBGRPROD').setValue("");
           widget.getField('CDSUBGRPROD').readOnly = true;
            widget.getField('TCDSUBGRPROD').reload();
           widget.getField('NMPRODUTOINI').reload();
           widget.getField('NMPRODUTOFIN').reload();
        }
        widget.reload();
    };
    
    
    this.setDataSourceFilterApply = function(args){

        var valuesWidget = templateManager.container.factoredWidgets.filter((widget) => {return widget._filteredWidgetId == args.owner.id;});
        if(valuesWidget[0].isValid()){

            var rowPopup = valuesWidget[0].currentRow;
            var dataSourceFilter = [];
            
            /* CAMPO DE FILIAL NO DATASOURCEFILTER */
            var filiais = '';
            var nrSol = '';
            var subGrupo = '';
            
            General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
                var filial = response.dataset.filial[0].CDFILIAL;

                /* CAMPO DE FILIAL DE PRODUCAO */
                var dataSource = templateManager.container.getWidget('gridSolicitaCompra').dataSource.name;
                if((dataSource == 'ped_pedidos#/crud/filial_solicita_pedidos_data') || (dataSource == 'ped_pedidos#/crud/filial_solicita_pedidos_data_grupo')){
                    dataSourceFilter.push(
                        {
                            name: "P_FILIPROC",
                            operator: "=",
                            value: filial
                        }
                    );
                }
                
                if(!rowPopup.CDFILSOLI || rowPopup.CDFILSOLI.length == 0){
                    dataSourceFilter.push({
                            "name": 'P_TCDFILIAL',
                            "operator": "=",
                            "value": 'T'
                    });
                }else{
                    rowPopup.CDFILSOLI.forEach(function(filial){
                        filiais += "_" + filial;
                    });
                    filiais = filiais + "_";
                    
                    dataSourceFilter.push({
                        "name": 'P_CDFILIAL',
                        "operator": "=",
                        "value": filiais
                    });
                }
               
                /* CAMPO DE NRSOLICITAÇÃO NO DATASOURCEFILTER */
                if(!rowPopup.NRSOLICMP){
                    dataSourceFilter.push(
                        {
                            "name": 'P_TNRSOLI',
                            "operator": "=",
                            "value": 'T'
                        },
                        {
                            "name": 'P_NRSOLICMP',
                            "operator": "=",
                            "value": null
                        }
                    );
                }else{
                    rowPopup.NRSOLICMP.forEach(function(nrSoli){
                        nrSol += "_" + nrSoli + rowPopup.CDFILISOLICMP;
                    });
                    nrSol = nrSol + "_";
                    
                    dataSourceFilter.push({
                        "name": 'P_NRSOLICMP',
                        "operator": "=",
                        "value": nrSol
                    });
                }
                 
                
                /* CAMPO DE DATA DE SOLICITAÇÃO NO DATASOURCEFILTER */
                dataSourceFilter.push(
                    {
                        "name": 'P_DTDESOLI',
                        "operator": "=",
                        "value": rowPopup.DTSOLCMP.start
                    },
                    {
                        "name": 'P_DTATESOLI',
                        "operator": "=",
                        "value": rowPopup.DTSOLCMP.end
                    },
                    {
                        "name": 'P_TDTSOLI',
                        "operator": "=",
                        "value": null
                    }
                );
                if(rowPopup.DTPROGENTR.start != '' && rowPopup.DTPROGENTR.end != ''){
                   dataSourceFilter.push( 
                        {
                            "name": 'P_DTINIENT',
                            "operator": "=",
                            "value": rowPopup.DTPROGENTR.start
                        },
                        {
                            "name": 'P_DTFINENT',
                            "operator": "=",
                            "value": rowPopup.DTPROGENTR.end
                        },
                        {
                            "name": 'P_TDTENT',
                            "operator": "=",
                            "value": null
                        }
                    );
                }else{
                    dataSourceFilter.push( 
                        {
                            "name": 'P_DTINIENT',
                            "operator": "=",
                            "value": null
                        },
                        {
                            "name": 'P_DTFINENT',
                            "operator": "=",
                            "value": null
                        },
                        {
                            "name": 'P_TDTENT',
                            "operator": "=",
                            "value": 'T'
                        }
                    );
                }
                
                /* CAMPO DE PRODUTO INICIALE FINAL NO DATASOURCEFILTER */
                if(rowPopup.CDPRODUTOINI && rowPopup.CDPRODUTOFIN){
                    
                    dataSourceFilter.push(
                        {
                            "name": 'P_TPRODUTO',
                            "operator": "=",
                            "value": null
                        },
                        {
                            "name": 'PRODINI',
                            "operator": "=",
                            "value": rowPopup.CDPRODUTOINI
                        }
                        
                    );   
                    if(rowPopup.SUBGRUPSN == "N"){
                        dataSourceFilter.push(
                            {
                                "name": 'PRODFIM',
                                "operator": "=",
                                "value": rowPopup.CDPRODUTOFIN + 'ZZZZZZZZZ'
                            }
                        );
                    }else{
                       dataSourceFilter.push(
                            {
                                "name": 'PRODFIM',
                                "operator": "=",
                                "value": rowPopup.CDPRODUTOFIN
                            }
                        ); 
                    }
                }else{
                    dataSourceFilter.push(
                        {
                            "name": 'P_TPRODUTO',
                            "operator": "=",
                            "value": 'T'
                        },
                        {
                            "name": 'PRODINI',
                            "operator": "=",
                            "value": null
                        },
                        {
                            "name": 'PRODFIM',
                            "operator": "=",
                            "value": null
                        }
                        
                    );
                }
                
                /* CAMPO DE PRODUTO INICIALE FINAL NO DATASOURCEFILTER */
                if(rowPopup.SUBGRUPSN == "S"){
                    dataSourceFilter.push(
                        {
                            "name": 'P_CDGRUPPROD',
                            "operator": "=",
                            "value": rowPopup.CDGRUPPROD
                        }
                    );
                    if(rowPopup.TCDSUBGRPROD == "T"){
                        dataSourceFilter.push(
                            {
                                "name": 'P_TCDSUBGRPROD',
                                "operator": "=",
                                "value": 'T'
                            },
                            {
                                "name": 'P_CDSUBGRPROD',
                                "operator": "=",
                                "value": null
                            }
                        );
                    } else if(rowPopup.TCDSUBGRPROD == "L"){
                        var subGrProd ="";
                        rowPopup.CDSUBGRPROD.forEach(function(prod){
                            subGrProd += "_" + prod;
                        });
                        subGrProd = subGrProd + "_";
                        
                        dataSourceFilter.push(
                            {
                                "name": 'P_TCDSUBGRPROD',
                                "operator": "=",
                                "value": null
                            },
                            {
                                "name": 'P_CDSUBGRPROD',
                                "operator": "=",
                                "value": subGrProd
                            }
                        );
                    }
                }
                args.owner.dataSourceFilter =[];
                args.owner.dataSourceFilter = dataSourceFilter;
                args.owner.container.getWidget('gridSolicitaCompra').reload();
            }.bind(this));  
        }
     
    };
    
    this.closeRetorno = function(){
        var widget = templateManager.container.getWidget('gridSolicitaCompra');
        ScreenService.closePopup();
        widget.unSelectAll();
        widget.getAction('importarSolicitacoes').isVisible = false;
        widget.reload();
    };
    
};
    
    Configuration(function (ContextRegister) {
	ContextRegister.register('Ped05700_importacao_Solicitacao_Compras_Controller', Ped05700_importacao_Solicitacao_Compras_Controller);
});