const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const alvarasPage = require('../../../page-objects/parametrizacao/pedidos/alvarasELicenciamento.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const alvaraGridId = '16978579311919027227234';
describe('Tela Alvarás e Licenciamento de produção e comercialização', () => {
	beforeEach(() => {
		browser.get('http://erpteste.teknisa.com/login/');
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		alvarasPage.abrir();
	});

	afterEach(() => {
		geral.sair();
	});

	it('Deve acessar a tela Alvarás e Licenciamento de produção e comercialização', () => {
		expect(z.component.header.getTitle())
			.toBe('Alvarás e Licenciamento de produção e comercialização');
	});

	it('Deve adicionar um alvará', () => {
		geral.clickAdicionar();
		geral.clickAndFllField('NMALVARA', j.getValor('alvara'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${alvaraGridId}`)));

		expect(geral.gridHasText(alvaraGridId, j.getValor('alvara'), 1))
			.toBe(j.getValor('alvara'));
	});

	it('Deve editar um alvará', () => {
		geral.filterIt(j.getValor('alvara'));
		geral.clickGrid('NMALVARA', j.getValor('alvara'), alvaraGridId);
		geral.clickEditar();
		geral.fillField('NMALVARA', j.getValor('alvara1'));
		geral.clickSalvar();
		geral.waitFieldVisibility('NMALVARA');

		expect(geral.getTextoPorId('NMALVARA'))
			.toBe(j.getValor('alvara1'));
	});

	it('Deve excluir um alvará', () => {
		geral.filterIt(j.getValor('alvara1'));
		geral.clickGrid('NMALVARA', j.getValor('alvara1'), alvaraGridId);
		geral.clickExcluir();
		geral.clickSim();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${alvaraGridId}`)));

		expect(geral.gridHasText(alvaraGridId, j.getValor('alvara1'), 1))
			.toBeUndefined();
	});
});
